// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIForm;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 If an action is preformed, everything within the next parent form belongs to the submit-area.
  An action could be a button which is pressed.
  tc:page is a form.
  Everything in the submit-area is written into the model, even other forms.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.FormTagDeclaration}.
 */
@Generated("component.stg")
public class UIForm
    extends AbstractUIForm implements ClientBehaviorHolder {

  public static final String COMPONENT_TYPE = Tags.form.componentType();

  public static final String COMPONENT_FAMILY = "javax.faces.Form";


  enum PropertyKeys {
    markup,
    inline,
    plain,
    customClass,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Flag indicating this component should rendered as an inline element.
  <br>Default: <code>false</code>
  @deprecated*/
  @Deprecated
  public boolean isInline() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.inline);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  @Deprecated
  public void setInline(boolean inline) {
      Deprecation.LOG.error("The attribute 'inline' of 'UIForm' is deprecated. "
          + "Please refer the documentation for further information.");
    getStateHelper().put(PropertyKeys.inline, inline);
  }

  /**
  <p><b>Use with caution: Only for special cases!</b></p>

   <p>This attribute is useful for tc:out if labelLayout=skip is set.
   Use true, if you want to only render the text (no surrounding tag).
   Use false, if you enable the possibility to apply styles to the output.</p>

   <p>For tc:form there will no div tag be rendered. So, the content
   can be used freely from layout managers.</p>

   <p>But, no AJAX is possible for components with "plain" set,
   because there is no client element with an "id" in the DOM.</p>
  <br>Default: <code>false</code>
  */
  public boolean isPlain() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.plain);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setPlain(boolean plain) {
    getStateHelper().put(PropertyKeys.plain, plain);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}